// Lösungen zu "Richard Kaiser: C++ mit dem Borland C++Builder 2007", ISBN: 978-3-540-69575-2
// Copyright Richard Kaiser, 2007. http://www.rkaiser.de. All rights reserved.
// Diese Quelltexte dürfen in eigenen Programmen verwendet werden, wenn sie einen Hinweis auf die Quelle (die ersten beiden Zeilen) enthalten. In keinem Fall wird eine Haftung für direkte, indirekte, zufällige oder Folgeschäden übernommen, die sich aus der Nutzung ergeben.
// It is permitted to use this source text in programs of your own, provided that it contains a reference to the source (the first two lines above). All liabilities for use of the code are disclaimed.

//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "EnumU.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------

void showBorderstyle()
{
if (Form1->BorderStyle == bsDialog)
  Form1->Dialog->Checked=true;
else if (Form1->BorderStyle == bsSingle)
  Form1->Single->Checked=true;
else if (Form1->BorderStyle == bsSizeable)
  Form1->Sizeable->Checked=true;
else if (Form1->BorderStyle == bsNone)
  Form1->None->Checked=true;
else if (Form1->BorderStyle == bsToolWindow)
  Form1->ToolWindow->Checked=true;
else if (Form1->BorderStyle == bsSizeToolWin)
  Form1->SizeToolWin->Checked=true;
}
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
showBorderstyle();
}


// --------------- Aufgabe 1 -------------------------------

void __fastcall TForm1::Button_3_15_1Click(TObject *Sender)
{
// a) Ohne den Umlaut in "März" möglich
enum Monate {Januar=1, Februar, /* März, */ April, Mai, Juni,
     Juli,  August, September, Oktober, November, Dezember};
     // nicht möglich: mehrfache Deklarationen
// enum Sommer {Juni, Juli,  August};

// b)
// Nicht möglich, da die Enumeratoren Ganzzahlkonstanten sein müssen.
// enum Monate {Jan = "Januar", Februar = "Februar"};

// c)
// möglich
enum {max=100};
int a[max];
}


// --------------- Aufgabe 2 a) ----------------------------

void __fastcall TForm1::DialogClick(TObject *Sender)
{
Form1->BorderStyle = bsDialog;
showBorderstyle();
}

void __fastcall TForm1::SingleClick(TObject *Sender)
{
Form1->BorderStyle = bsSingle;
showBorderstyle();
}

void __fastcall TForm1::SizeableClick(TObject *Sender)
{
Form1->BorderStyle = bsSizeable;
showBorderstyle();
}

void __fastcall TForm1::NoneClick(TObject *Sender)
{
Form1->BorderStyle = bsNone;
showBorderstyle();
}

void __fastcall TForm1::ToolWindowClick(TObject *Sender)
{
Form1->BorderStyle = bsToolWindow;
showBorderstyle();
}

void __fastcall TForm1::SizeToolWinClick(TObject *Sender)
{
Form1->BorderStyle = bsSizeToolWin;
showBorderstyle();
}


// --------------- Aufgabe 2 b) ----------------------------

/* In der Online-Hilfe findet man:

      typedef TFormBorderStyle TBorderStyle;

   und

     enum TFormBorderStyle { bsNone, bsSingle, bsSizeable, bsDialog, bsToolWindow, bsSizeToolWin };

   Damit ergibt sich die Lösung z. B. folgendermaßen:
*/

TFormBorderStyle bs=bsNone;

void __fastcall TForm1::Button_3_15_2Click(TObject *Sender)
{
if (bs<bsSizeToolWin) bs=bs+1;
else bs=bsNone;
Form1->BorderStyle = bs;
showBorderstyle();
}

